#!/usr/bin/env bash


REQUIRED_TOOLS="rt redmine jq"
which ${REQUIRED_TOOLS[@]} > /dev/null
if [[ 0 != $? ]] ; then
    echo "[-] You must have the following tools: ${REQUIRED_TOOLS}"
    exit 1
fi

printf ">>> SUPPORT RT <<<\n"
short_list_regex="^\([0-9]\+\)[[:blank:]]\+\([^\t]\+\)\t\(.*\)\\t\(.*\)"
new_output_regex="\1 [ \4 ] - < \3 >\\n\\t~> '\2'"
rt ls -t tickets \
    -f requestors,subject,lastupdated \
    -q csn-monsyndicat,comptes,info,support,ventes,production \
    -o +lastupdated -s "(Status = 'new' OR Status = 'open') AND Owner = 'Nobody'" \
     | sed -e "s/$short_list_regex/$new_output_regex/g" \
     | tail -n +2

printf "\n>>> SUPPORT REDMINE <<<\n"
printf "\n[+] demandes passées date\n"
redmine issues --query 239 -l 150 --sort updated_on:desc --json \
    | jq -r '.[]|(.id|tostring)+" [ "+(.updated_on|fromdate|strftime("%a %d %b %Y %T"))+" ] - "+if .assigned_to.name then .assigned_to.name else "Nobody" end+"\t("+.status.name+")\n\t~> "+.subject+" <"+.project.name[:17]+">"'
printf "\n[+] demandes non triées\n"
redmine issues --query 236 -l 150 --sort updated_on:desc --json \
    | jq -r '.[]|(.id|tostring)+" [ "+(.updated_on|fromdate|strftime("%a %d %b %Y %T"))+" ] - "+if .assigned_to.name then .assigned_to.name else "Nobody" end+"\t("+.status.name+")\n\t~> "+.subject+" <"+.project.name[:17]+">"'
printf "\n[+] demandes dûes cette semaine\n"
redmine issues --query 237 -l 150 --sort updated_on:desc --json \
    | jq -r '.[]|(.id|tostring)+" [ "+(.updated_on|fromdate|strftime("%a %d %b %Y %T"))+" ] - "+if .assigned_to.name then .assigned_to.name else "Nobody" end+"\t("+.status.name+")\n\t~> "+.subject+" <"+.project.name[:17]+">"'
printf "\n[+] demandes prévues dans plus d'une semaine\n"
redmine issues --query 238 -l 150 --sort updated_on:desc --json \
    | jq -r '.[]|(.id|tostring)+" [ "+(.updated_on|fromdate|strftime("%a %d %b %Y %T"))+" ] - "+if .assigned_to.name then .assigned_to.name else "Nobody" end+"\t("+.status.name+")\n\t~> "+.subject+" <"+.project.name[:17]+">"'
printf "\n[+] demandes interne\n"
redmine issues --query 246 -l 150 -P kt-sysadmin --sort updated_on:desc --json \
    | jq -r '.[]|(.id|tostring)+" [ "+(.updated_on|fromdate|strftime("%a %d %b %Y %T"))+" ] - "+if .assigned_to.name then .assigned_to.name else "Nobody" end+"\t("+.status.name+")\n\t~> "+.subject+" <"+.project.name[:17]+">"'
