#!/usr/bin/env bash

REQUIRED_TOOLS="rt redmine jq"
which ${REQUIRED_TOOLS[@]} > /dev/null
if [[ 0 != $? ]] ; then
    echo "[-] You must have the following tools: ${REQUIRED_TOOLS}"
    exit 1
fi

new_output_regex="\1 [ \4 ] - \2\\t< \3 >";
short_list_regex="^\([0-9]\+\)[[:blank:]]\+\([^\t]\+\)\t\(.*\)\\t\(.*\)";

printf ">>> VENTES RT <<<\n"
rt ls -f lastupdated,owner,subject -o +lastupdated "Queue = 'Ventes' and (Status = 'open' or Status = 'new') and CF.{Équipe} LIKE 'Sysadmin'" | sed -e "s/$short_list_regex/$new_output_regex/g" | tail -n +2

printf "\n[+] ventes stalled:\n"
rt ls -f lastupdated,owner,subject -o +lastupdated "Queue = 'Ventes' and Status = 'stalled' and CF.{Équipe} LIKE 'Sysadmin'" | sed -e "s/$short_list_regex/$new_output_regex/g" | tail -n +2

printf "\n>>> VENTES REDMINE <<<\n"
redmine issues -P clients --query 241 -l 150 --sort updated_on:desc --json \
    | jq -r '.[]|(.id|tostring)+" [ "+(.updated_on|fromdate|strftime("%a %d %b %Y %T"))+" ] - "+.assigned_to.name[:10]+"\t("+.status.name+") "+.subject+" <"+.project.name[:17]+">"'

printf "\n[+] support client:\n"
redmine issues -P clients --query 232 -l 150 --sort updated_on:desc --json \
    | jq -r '.[]|(.id|tostring)+" [ "+(.updated_on|fromdate|strftime("%a %d %b %Y %T"))+" ] - "+.assigned_to.name[:10]+"\t("+.status.name+") "+.subject+" <"+.project.name[:17]+">"'

printf "\n[+] projet dev:\n"
redmine issues -P clients --query 244 -l 150 --sort updated_on:desc --json \
    | jq -r '.[]|(.id|tostring)+" [ "+(.updated_on|fromdate|strftime("%a %d %b %Y %T"))+" ] - "+.assigned_to.name[:10]+"\t("+.status.name+") "+.subject+" <"+.project.name[:17]+">"'
